// THIS PROGRAM IS PROVIDED "AS IS". TI MAKES NO WARRANTIES OR
// REPRESENTATIONS, EITHER EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS 
// FOR A PARTICULAR PURPOSE, LACK OF VIRUSES, ACCURACY OR 
// COMPLETENESS OF RESPONSES, RESULTS AND LACK OF NEGLIGENCE. 
// TI DISCLAIMS ANY WARRANTY OF TITLE, QUIET ENJOYMENT, QUIET 
// POSSESSION, AND NON-INFRINGEMENT OF ANY THIRD PARTY 
// INTELLECTUAL PROPERTY RIGHTS WITH REGARD TO THE PROGRAM OR 
// YOUR USE OF THE PROGRAM.
//
// IN NO EVENT SHALL TI BE LIABLE FOR ANY SPECIAL, INCIDENTAL, 
// CONSEQUENTIAL OR INDIRECT DAMAGES, HOWEVER CAUSED, ON ANY 
// THEORY OF LIABILITY AND WHETHER OR NOT TI HAS BEEN ADVISED 
// OF THE POSSIBILITY OF SUCH DAMAGES, ARISING IN ANY WAY OUT 
// OF THIS AGREEMENT, THE PROGRAM, OR YOUR USE OF THE PROGRAM. 
// EXCLUDED DAMAGES INCLUDE, BUT ARE NOT LIMITED TO, COST OF 
// REMOVAL OR REINSTALLATION, COMPUTER TIME, LABOR COSTS, LOSS 
// OF GOODWILL, LOSS OF PROFITS, LOSS OF SAVINGS, OR LOSS OF 
// USE OR INTERRUPTION OF BUSINESS. IN NO EVENT WILL TI'S 
// AGGREGATE LIABILITY UNDER THIS AGREEMENT OR ARISING OUT OF 
// YOUR USE OF THE PROGRAM EXCEED FIVE HUNDRED DOLLARS 
// (U.S.$500).
//
// Unless otherwise stated, the Program written and copyrighted 
// by Texas Instruments is distributed as "freeware".  You may, 
// only under TI's copyright in the Program, use and modify the 
// Program without any charge or restriction.  You may 
// distribute to third parties, provided that you transfer a 
// copy of this license to the third party and the third party 
// agrees to these terms by its first use of the Program. You 
// must reproduce the copyright notice and any other legend of 
// ownership on each copy or partial copy, of the Program.
//
// You acknowledge and agree that the Program contains 
// copyrighted material, trade secrets and other TI proprietary 
// information and is protected by copyright laws, 
// international copyright treaties, and trade secret laws, as 
// well as other intellectual property laws.  To protect TI's 
// rights in the Program, you agree not to decompile, reverse 
// engineer, disassemble or otherwise translate any object code 
// versions of the Program to a human-readable form.  You agree 
// that in no event will you alter, remove or destroy any 
// copyright notice included in the Program.  TI reserves all 
// rights not specifically granted under this license. Except 
// as specifically provided herein, nothing in this agreement 
// shall be construed as conferring by implication, estoppel, 
// or otherwise, upon you, any license or other right under any 
// TI patents, copyrights or trade secrets.
//
//*******************************************************************************
//	ScanIF Demo LCD functions
//	Description:	This LCD functions applicable for application note slaa578.
//					Modification should be made for any other LCDs
//
//  Zack Mak
//  Texas Instruments, Inc
//  January 2014
//******************************************************************************

#include "msp430xw42x.h"
#define __msp430xW42x

#define UPSIDEDOWN

// Table for displaying digits
const char disp_num[10] = {

#ifndef UPSIDEDOWN
	0xFC,	// 0
	0x60,	// 1
	0xDB,	// 2
	0xF3,	// 3
	0x67,	// 4
	0xB7,	// 5
	0xBF,	// 6
	0xE0,	// 7
	0xFF,	// 8
	0xF7,	// 9
#else
	// Upside down
	0xFC,	// 0
	0x0C,	// 1
	0xDB,	// 2 
	0x9F,	// 3
	0x2F,	// 4
	0xB7,	// 5
	0xF7,	// 6 
	0x1C,	// 7
	0xFF,	// 8
	0xBF,	// 9
#endif
};

void InitLCD(void)
{
	P5SEL |= BIT2 + BIT3 + BIT4 + BIT5 + BIT6 + BIT7;
	BTCTL = 0x10;		// ACLK/128
	LCDM1 = 0;
	LCDM2 = 0;
	LCDM3 = 0;
	LCDM4 = 0;
	LCDM5 = 0;
	LCDM6 = 0;
	LCDM7 = 0;
	LCDM8 = 0;
	LCDM9 = 0;
	LCDM10 = 0;
	LCDM11 = 0;
	LCDM12 = 0;
	LCDM13 = 0;
	LCDM14 = 0;
	LCDM15 = 0;
	LCDM16 = 0;
	LCDM17 = 0;
	LCDM18 = 0;
	LCDM19 = 0;
	LCDM20 = 0;
	LCDCTL = 0x3D;		// S0-S15, 4-MUX, LCDSON, LCDON
}

void DisplayCAL(void)		// Display "CAL" on the LCD
{
#ifndef UPSIDEDOWN
	LCDM4 = 0x9C;	// C
	LCDM5 = 0xEF;	// A
	LCDM6 = 0x1C;	// L
#else
	// Upside down
	LCDM6 = 0xF0;	// C
	LCDM5 = 0x7F;	// A
	LCDM4 = 0xE0;	// L
#endif
}

void DisplayByte(unsigned char num)		// Display number on the LCD
{
	char hundred = 0, ten = 0;

	while (num >= 100)
	{
		num -= 100;
		hundred++;
	}
	while (num >= 10)
	{
		num -= 10;
		ten++;
	}
#ifndef UPSIDEDOWN
	LCDM6 = disp_num[num];

	if (ten || hundred)	LCDM5 = disp_num[ten];
	else				LCDM5 = 0x00;

	if (hundred)		LCDM4 = disp_num[hundred];
	else				LCDM4 = 0x00;
#else
	LCDM4 = disp_num[num];

	if (ten || hundred)	LCDM5 = disp_num[ten];
	else				LCDM5 = 0x00;

	if (hundred)		LCDM6 = disp_num[hundred];
	else				LCDM6 = 0x00;
#endif
}
